/*  definitions of signal processing routines */

float  walsh(float x,int order);
float  hadamard(float x,int order);
int    gray_sort(float *out,float *in,int num);
int    sort_wals(float *out,float *in,int num);
void   fast_walsh(float *in,float *out,int num);

/* fast Fourier transforms */

void  fft(float *a,float *b,int n,int s);

void   fourt(float huge *a, int *values, int dimensions, int sign, int complex);

/* maximum entropy spectral estimator */

int   Burg(float *x,int data_length,int total_length,
           int estimator_length);

/* least squares periodogram analysis */

float lomb_scargle(float *t,float *v,int n,float *f,float *p,int m,
                   int sample,int *largest);

/* median filter and related routines */

float  insert(float *a,int current,int middle);
float  insert_sort(float *a,int num,int median);
int    median_filter(float *a,int num,int length);

